diff -c /dev/null xc/lib/Xmu/Xmuos2.def:3.0
*** /dev/null	Mon Jan 30 17:47:49 1995
--- xc/lib/Xmu/Xmuos2.def	Mon Jan 30 17:47:49 1995
***************
*** 0 ****
--- 1,112 ----
+ LIBRARY Xmu
+ DESCRIPTION "X11R6 XFree86 libXmu.dll for OS/2 EMX08H VERSION=6.0"
+ CODE
+ 	PRELOAD
+ DATA
+ 	SINGLE NONSHARED
+ STACKSIZE 32768
+ EXPORTS
+ 	XmuGetAtomName  @ 1
+ 	XmuInternAtom  @ 2
+ 	XmuInternStrings  @ 3
+ 	XmuMakeAtom  @ 4
+ 	XmuNameOfAtom  @ 5
+ 	XmuCopyISOLatin1Lowered  @ 6
+ 	XmuCopyISOLatin1Uppered  @ 7
+ 	XmuCompareISOLatin1  @ 8
+ 	XmuAddCloseDisplayHook  @ 9
+ 	XmuLookupCloseDisplayHook  @ 10
+ 	XmuRemoveCloseDisplayHook  @ 11
+ 	XmuCvtFunctionToCallback  @ 12
+ 	XmuCvtStringToBackingStore  @ 13
+ 	XmuCvtStringToCursor  @ 14
+ 	XmuCvtStringToColorCursor  @ 15
+ 	XmuCvtStringToGravity  @ 16
+ 	XmuCvtStringToJustify  @ 17
+ 	XmuCvtStringToLong  @ 18
+ 	XmuCvtStringToOrientation  @ 19
+ 	XmuCvtStringToBitmap  @ 20
+ 	XmuCvtStringToShapeStyle  @ 21
+ 	XmuReshapeWidget  @ 22
+ 	XmuCvtStringToWidget  @ 23
+ 	XmuNewCvtStringToWidget  @ 24
+ 	XmuCursorNameToIndex  @ 25
+ 	XmuDQCreate  @ 26
+ 	XmuDQDestroy  @ 27
+ 	XmuDQLookupDisplay  @ 28
+ 	XmuDQAddDisplay  @ 29
+ 	XmuDQRemoveDisplay  @ 30
+ 	XmuDrawRoundedRectangle  @ 31
+ 	XmuFillRoundedRectangle  @ 32
+ 	XmuDrawLogo  @ 33
+ 	XmuCreatePixmapFromBitmap  @ 34
+ 	XmuCreateStippledPixmap  @ 35
+ 	XmuReleaseStippledPixmap  @ 36
+ 	XmuLocateBitmapFile  @ 37
+ 	XmuLocatePixmapFile  @ 38
+ 	XmuReadBitmapData  @ 39
+ 	XmuReadBitmapDataFromFile  @ 40
+ 	XmuPrintDefaultErrorMessage  @ 41
+ 	XmuSimpleErrorHandler  @ 42
+ 	XmuRegisterExternalAgent  @ 43
+ 	XmuCallInitializers  @ 44
+ 	XmuAddInitializer  @ 45
+ 	XmuAllStandardColormaps  @ 46
+ 	XmuCreateColormap  @ 47
+ 	XmuDeleteStandardColormap  @ 48
+ 	XmuGetColormapAllocation  @ 49
+ 	XmuLookupStandardColormap  @ 50
+ 	XmuStandardColormap  @ 51
+ 	XmuVisualStandardColormaps  @ 52
+ 	XmuConvertStandardSelection  @ 53
+ 	XmuGetHostname  @ 54
+ 	XmuWnInitializeNodes  @ 55
+ 	XmuWnFetchResources  @ 56
+ 	XmuWnCountOwnedResources  @ 57
+ 	XmuWnNameToNode  @ 58
+ 	XmuClientWindow  @ 59
+ 	XmuUpdateMapHints  @ 60
+ 	XmuScreenOfWindow  @ 61
+ 	XctCreate  @ 62
+ 	XctNextItem  @ 63
+ 	XctFree  @ 64
+ 	XctReset  @ 65
+ 	_XmuCCLookupDisplay  @ 66
+ 	_XEditResCheckMessages  @ 67 
+ 	_XEditResPutString8  @ 68
+ 	_XEditResPut8  @ 69
+ 	_XEditResPut16  @ 70
+ 	_XEditResPut32  @ 71
+ 	_XEditResPutWidgetInfo  @ 72
+ 	_XEditResResetStream  @ 74
+ 	_XEditResGet8  @ 75
+ 	_XEditResGet16  @ 76
+ 	_XEditResGetSigned16  @ 77
+ 	_XEditResGet32  @ 78
+ 	_XEditResGetString8  @ 79
+ 	_XEditResGetWidgetInfo  @ 80
+ 	_XA_ATOM_PAIR  @ 81
+ 	_XA_CHARACTER_POSITION  @ 82
+ 	_XA_CLASS  @ 83
+ 	_XA_CLIENT_WINDOW  @ 84
+ 	_XA_CLIPBOARD  @ 85
+ 	_XA_COMPOUND_TEXT  @ 86
+ 	_XA_DECNET_ADDRESS  @ 87
+ 	_XA_DELETE  @ 88
+ 	_XA_FILENAME  @ 89
+ 	_XA_HOSTNAME  @ 90
+ 	_XA_IP_ADDRESS  @ 91
+ 	_XA_LENGTH  @ 92
+ 	_XA_LIST_LENGTH  @ 93
+ 	_XA_NAME  @ 94
+ 	_XA_NET_ADDRESS  @ 95
+ 	_XA_NULL  @ 96
+ 	_XA_OWNER_OS  @ 97
+ 	_XA_SPAN  @ 98
+ 	_XA_TARGETS  @ 99
+ 	_XA_TEXT  @ 100
+ 	_XA_TIMESTAMP  @ 101
+ 	_XA_USER  @ 102
+ 	XmuDistinguishableColors @ 103
+ 	XmuDistinguishablePixels @ 104
+ 	
diff -c /dev/null xc/lib/Xmu/Xmuos2.rsp:3.0
*** /dev/null	Mon Jan 30 17:47:49 1995
--- xc/lib/Xmu/Xmuos2.rsp	Mon Jan 30 17:47:49 1995
***************
*** 0 ****
--- 1,10 ----
+ AllCmap.obj Atoms.obj ClientWin.obj CloseHook.obj CmapAlloc.obj CrCmap.obj+
+ CrPixFBit.obj CursorName.obj CvtCache.obj CvtStdSel.obj DefErrMsg.obj+
+ DelCmap.obj DisplayQue.obj Distinct.obj DrRndRect.obj DrawLogo.obj+
+ EditresCom.obj ExtAgent.obj FToCback.obj GetHost.obj GrayPixmap.obj+
+ Initer.obj LocBitmap.obj Lookup.obj LookupCmap.obj Lower.obj RdBitF.obj+
+ ScrOfWin.obj ShapeWidg.obj StdCmap.obj StrToBS.obj StrToBmap.obj StrToCurs.obj+
+ StrToGrav.obj StrToJust.obj StrToLong.obj StrToOrnt.obj StrToShap.obj+
+ StrToWidg.obj UpdMapHint.obj VisCmap.obj WidgetNode.obj Xct.obj /NOL /NOD /BAT
+ Xmu.dll
+ 
diff -c xc/lib/Xt/Create.c:1.1.1.1 xc/lib/Xt/Create.c:3.1
*** xc/lib/Xt/Create.c:1.1.1.1	Mon Jan 30 17:47:56 1995
--- xc/lib/Xt/Create.c	Mon Jan 30 17:47:56 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: Create.c,v 1.105 94/04/17 20:13:54 converse Exp $ */
+ /* $XFree86: xc/lib/Xt/Create.c,v 3.1 1995/01/07 04:00:59 dawes Exp $ */
  
  /***********************************************************
  Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
diff -c xc/lib/Xt/Imakefile:1.1.1.1 xc/lib/Xt/Imakefile:3.0
*** xc/lib/Xt/Imakefile:1.1.1.1	Mon Jan 30 17:47:57 1995
--- xc/lib/Xt/Imakefile	Mon Jan 30 17:47:57 1995
***************
*** 1,4 ****
--- 1,5 ----
  XCOMM $XConsortium: Imakefile,v 1.110 94/04/04 21:54:23 gildea Exp $
+ XCOMM $XFree86: xc/lib/Xt/Imakefile,v 3.0 1994/06/28 12:23:47 dawes Exp $
  #define DoNormalLib NormalLibXt
  #define DoSharedLib SharedLibXt
  #define DoDebugLib DebugLibXt
***************
*** 209,214 ****
--- 210,218 ----
  SpecialCLibObjectRule(TMaction,$(_NOOP_),$(RCONST_DEFINES))
  #if DoSharedLib
  SpecialCObjectRule(sharedlib,$(_NOOP_),$(SHLIBDEF))
+ #endif
+ #ifdef MinixArchitecture
+ SpecialCLibObjectRule(Shell,$(ICONFIGFILES),-DXT_NO_SM)
  #endif
  
  DependTarget()
diff -c xc/lib/Xt/Initialize.c:1.1.1.2 xc/lib/Xt/Initialize.c:3.3
*** xc/lib/Xt/Initialize.c:1.1.1.2	Mon Jan 30 17:47:57 1995
--- xc/lib/Xt/Initialize.c	Mon Jan 30 17:47:57 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: Initialize.c,v 1.222 94/12/12 18:59:11 kaleb Exp $ */
+ /* $XFree86: xc/lib/Xt/Initialize.c,v 3.3 1995/01/28 15:43:57 dawes Exp $ */
  
  /***********************************************************
  Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts
diff -c xc/lib/Xt/Intrinsic.c:1.1.1.2 xc/lib/Xt/Intrinsic.c:3.3
*** xc/lib/Xt/Intrinsic.c:1.1.1.2	Mon Jan 30 17:47:58 1995
--- xc/lib/Xt/Intrinsic.c	Mon Jan 30 17:47:58 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: Intrinsic.c,v 1.196 94/11/21 18:20:56 kaleb Exp $ */
+ /* $XFree86: xc/lib/Xt/Intrinsic.c,v 3.3 1995/01/28 15:44:00 dawes Exp $ */
  
  /***********************************************************
  Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
***************
*** 1054,1060 ****
      String	lang;
  {
  
! #if defined(hpux) || defined(CSRG_BASED) || defined(sun) || defined(SVR4) || defined(sgi) || defined(__osf__) || defined(AIXV3) || defined(ultrix) || defined(WIN32)
  #ifdef hpux
  #define SKIPCOUNT 2
  #define STARTCHAR ':'
--- 1055,1061 ----
      String	lang;
  {
  
! #if defined(hpux) || defined(CSRG_BASED) || defined(sun) || defined(SVR4) || defined(sgi) || defined(__osf__) || defined(AIXV3) || defined(ultrix) || defined(WIN32) || defined(__EMX__)
  #ifdef hpux
  #define SKIPCOUNT 2
  #define STARTCHAR ':'
***************
*** 1065,1071 ****
  #define STARTCHAR '\001'
  #define ENDCHAR '\001'
  #else
! #ifdef WIN32
  #define SKIPCOUNT 1
  #define STARTCHAR '='
  #define ENDCHAR ';'
--- 1066,1072 ----
  #define STARTCHAR '\001'
  #define ENDCHAR '\001'
  #else
! #if defined(WIN32) || defined(__EMX__)
  #define SKIPCOUNT 1
  #define STARTCHAR '='
  #define ENDCHAR ';'
diff -c xc/lib/Xt/Intrinsic.h:1.1.1.1 xc/lib/Xt/Intrinsic.h:3.0
*** xc/lib/Xt/Intrinsic.h:1.1.1.1	Mon Jan 30 17:47:59 1995
--- xc/lib/Xt/Intrinsic.h	Mon Jan 30 17:48:00 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: Intrinsic.h,v 1.199 94/04/17 20:14:22 converse Exp $ */
+ /* $XFree86: xc/lib/Xt/Intrinsic.h,v 3.0 1994/05/29 02:03:38 dawes Exp $ */
  
  /***********************************************************
  Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
***************
*** 2058,2065 ****
  #define XtDefaultFont		"XtDefaultFont"
  #define XtDefaultFontSet	"XtDefaultFontSet"
  
! #if defined(CRAY) || defined(__arm)
! #if __STDC__
  #define XtOffset(p_type,field) _Offsetof(p_type,field)
  #else
  #ifdef CRAY2
--- 2059,2066 ----
  #define XtDefaultFont		"XtDefaultFont"
  #define XtDefaultFontSet	"XtDefaultFontSet"
  
! #if defined(CRAY) || defined(__arm) || defined(__ACK)
! #if __STDC__ && !defined(__ACK)
  #define XtOffset(p_type,field) _Offsetof(p_type,field)
  #else
  #ifdef CRAY2
***************
*** 2072,2078 ****
  
  #endif	/* !CRAY2 */
  #endif  /* __STDC__ */
! #else	/* ! (CRAY || __arm) */
  
  #define XtOffset(p_type,field) \
  	((Cardinal) (((char *) (&(((p_type)NULL)->field))) - ((char *) NULL)))
--- 2073,2079 ----
  
  #endif	/* !CRAY2 */
  #endif  /* __STDC__ */
! #else	/* ! (CRAY || __arm || __ACK) */
  
  #define XtOffset(p_type,field) \
  	((Cardinal) (((char *) (&(((p_type)NULL)->field))) - ((char *) NULL)))
diff -c xc/lib/Xt/IntrinsicI.h:1.1.1.2 xc/lib/Xt/IntrinsicI.h:3.1
*** xc/lib/Xt/IntrinsicI.h:1.1.1.2	Mon Jan 30 17:48:01 1995
--- xc/lib/Xt/IntrinsicI.h	Mon Jan 30 17:48:01 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: IntrinsicI.h,v 1.59 94/10/10 18:57:48 kaleb Exp $ */
+ /* $XFree86: xc/lib/Xt/IntrinsicI.h,v 3.1 1995/01/12 05:56:08 dawes Exp $ */
  
  /***********************************************************
  
diff -c xc/lib/Xt/NextEvent.c:1.1.1.4 xc/lib/Xt/NextEvent.c:3.5
*** xc/lib/Xt/NextEvent.c:1.1.1.4	Mon Jan 30 17:48:01 1995
--- xc/lib/Xt/NextEvent.c	Mon Jan 30 17:48:02 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: NextEvent.c,v 1.145 94/10/10 18:59:29 kaleb Exp $ */
+ /* $XFree86: xc/lib/Xt/NextEvent.c,v 3.5 1995/01/12 05:56:10 dawes Exp $ */
  
  /***********************************************************
  Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
***************
*** 67,72 ****
--- 68,84 ----
  extern int errno;
  #endif
  
+ #ifdef __EMX__
+ #define BSD_SELECT
+ #include <sys/time.h>
+ #include <sys/select.h>
+ #endif
+ 
+ #ifdef MINIX
+ #include <sys/nbio.h>
+ #define select(n,r,w,x,t) nbio_select(n,r,w,x,t)
+ #endif
+ 
  static TimerEventRec* freeTimerRecs;
  static WorkProcRec* freeWorkRecs;
  static SignalEventRec* freeSignalRecs;
***************
*** 148,153 ****
--- 160,171 ----
  	    *howlong -= (time_spent.tv_sec*1000+time_spent.tv_usec/1000);
  }
  
+ #ifdef AMOEBA
+ /* For IoWait emulation: */
+ static int DoIgnoreEvents;
+ static int DoIgnoreInputs;
+ #endif
+ 
  typedef struct {
      struct timeval cur_time;
      struct timeval start_time;
***************
*** 221,226 ****
--- 239,245 ----
      wait_fds_ptr_t wf;
  {
      int ii;
+ #ifndef AMOEBA
  #ifndef USE_POLL
      wf->nfds = app->fds.nfds;
      if( !ignoreInputs ) {
***************
*** 260,265 ****
--- 279,288 ----
  		}
      }
  #endif
+ #else /* AMOEBA */
+     DoIgnoreEvents = ignoreEvents;
+     DoIgnoreInputs = ignoreInputs;
+ #endif /* AMOEBA */
  }
  
  static void AdjustTimes (app, block, howlong, ignoreTimers, wt)
***************
*** 290,295 ****
--- 313,320 ----
  #endif
  }
  
+ #ifndef AMOEBA
+ 
  static int IoWait (wt, wf)
      wait_times_ptr_t wt;
      wait_fds_ptr_t wf;
***************
*** 305,310 ****
--- 330,373 ----
  #endif
  }
  
+ #else /* AMOEBA */
+ 
+ static int AppIoWait (app, wt, wf)
+     XtAppContext app;
+     wait_times_ptr_t wt;
+     wait_fds_ptr_t wf;
+ {
+     /* Unfortunately we cannot use select() under Amoeba.  We call
+      * _X11TransAmSelect to wait for the display to produce input
+      * or until the timer runs out.  This has two disadvantages:
+      * - We cannot wait for multiple displays (we just wait for the
+      *   first display).
+      * - We cannot wait for other file descriptors (there is no easy solution
+      *   for this, but it seems that not too many applications need it).
+      * There is a workaround, however, in the form of XamSetSema and XamBlock,
+      * which allow you to wait for X events or other things.
+      */
+     long timout;
+     int nfound;
+ 
+     if (wt->wait_time_ptr != NULL) {
+ 	timout = wt->wait_time_ptr->tv_sec*1000 +
+ 		 (wt->wait_time_ptr->tv_usec+999)/1000;
+     } else {
+ 	timout = -1;
+     }
+     if ((DoIgnoreEvents || app->count == 0) && timout >= 0) {
+ 	millisleep(timout);
+ 	nfound = 0;
+     } else {
+ 	nfound = _X11TransAmSelect(ConnectionNumber(app->list[0]), timout);
+     }
+ 
+     return nfound;
+ }
+ 
+ #endif /* AMOEBA */
+ 
  static void FindInputs (app, wf, nfds, ignoreEvents, ignoreInputs, dpy_no, found_input)
      XtAppContext app;
      wait_fds_ptr_t wf;
***************
*** 317,322 ****
--- 380,386 ----
      XtInputMask condition;
      InputEvent *ep;
      int ii;
+ #ifndef AMOEBA
  #ifndef USE_POLL /* { check ready file descriptors block */
  #ifdef XTHREADS
      Fd_set rmask;
***************
*** 442,447 ****
--- 506,531 ----
  	}
      }
  #endif /* } */
+ #else /* AMOEBA */
+     int dd;
+ 
+     *dpy_no = -1;
+     *found_input = False;
+ 
+     for (ii = 0; ii < app->fds.nfds && nfds > 0; ii++) {
+ 	if (!ignoreEvents) {
+ 	    for (dd = 0; dd < app->count; dd++) {
+ 		if (ii == ConnectionNumber (app->list[dd])) {
+ 		    if (*dpy_no == -1) {
+ 			if (XEventsQueued (app->list[dd], QueuedAfterReading))
+ 			    *dpy_no = dd;
+ 		    }
+ 		}
+ 	    }
+ 	}
+ 	/* Inputs not implemented */
+     }
+ #endif /* AMOEBA */
  }
  
  /* 
***************
*** 587,593 ****
--- 671,681 ----
  	    push_thread = TRUE;
  	} else
  #endif /* } */
+ #ifndef AMOEBA
  	nfds = IoWait (&wt, &wf);
+ #else
+ 	nfds = AppIoWait (app, &wt, &wf);
+ #endif
  	if (nfds == -1) {
  	    /*
  	     *  interrupt occured recalculate time value and wait again.
***************
*** 945,950 ****
--- 1033,1039 ----
  	XtInputCallbackProc proc;
  	XtPointer closure;
  {
+ #ifndef AMOEBA
  	InputEvent* sptr;
  	XtInputMask condition = (XtInputMask) Condition;
  
***************
*** 987,992 ****
--- 1076,1085 ----
  	app->input_count++;
  	UNLOCK_APP(app);
  	return((XtInputId)sptr);
+ #else /* AMOEBA */
+         printf("XtAppAddInput not yet implemented\n");
+         abort();
+ #endif /* AMOEBA */
  }
  
  void XtRemoveInput( id )
diff -c xc/lib/Xt/Shell.c:1.1.1.4 xc/lib/Xt/Shell.c:3.2
*** xc/lib/Xt/Shell.c:1.1.1.4	Mon Jan 30 17:48:03 1995
--- xc/lib/Xt/Shell.c	Mon Jan 30 17:48:04 1995
***************
*** 1,4 ****
--- 1,5 ----
  /* $XConsortium: Shell.c,v 1.168 95/01/06 21:14:23 converse Exp $ */
+ /* $XFree86: xc/lib/Xt/Shell.c,v 3.2 1995/01/27 04:46:59 dawes Exp $ */
  
  /***********************************************************
  Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts
***************
*** 679,686 ****
--- 680,689 ----
  
  static XtResource sessionResources[]=
  {
+ #ifndef XT_NO_SM
   {XtNconnection, XtCConnection, XtRSmcConn, sizeof(SmcConn),
         Offset(session.connection), XtRSmcConn, (XtPointer) NULL},
+ #endif
   {XtNsessionID, XtCSessionID, XtRString, sizeof(String),
         Offset(session.session_id), XtRString, (XtPointer) NULL},
   {XtNrestartCommand, XtCRestartCommand, XtRCommandArgArray, sizeof(String*),
***************
*** 1103,1108 ****
--- 1106,1112 ----
      ArgList args;		/* unused */
      Cardinal *num_args;		/* unused */
  {
+ #ifndef XT_NO_SM
      SessionShellWidget w = (SessionShellWidget)new;
  
      if (w->session.session_id) w->session.session_id =
***************
*** 1134,1139 ****
--- 1138,1144 ----
  
      if (w->session.connection)
  	SetSessionProperties(w, True, 0L, 0L);
+ #endif /* !XT_NO_SM */
  }
  
  static void Resize(w)
***************
*** 1499,1504 ****
--- 1504,1510 ----
  					"WM_CLIENT_LEADER", False),
  			    XA_WINDOW, 32, PropModeReplace,
  			    (unsigned char *)(&(p->core.window)), 1);
+ #ifndef XT_NO_SM
  	if (p == (Widget) w) {
  	    for ( ; p->core.parent != NULL; p = p->core.parent);
  	    if (XtIsSubclass(p, sessionShellWidgetClass)) {
***************
*** 1514,1519 ****
--- 1520,1526 ----
  		}
  	    }
  	}
+ #endif /* !XT_NO_SM */
  
  	if (wmshell->wm.window_role)
  	    XChangeProperty(XtDisplay((Widget)w), XtWindow((Widget)w),
***************
*** 1670,1675 ****
--- 1677,1683 ----
  static void SessionDestroy(wid)
      Widget wid;
  {
+ #ifndef XT_NO_SM
      SessionShellWidget w = (SessionShellWidget) wid;
  
      StopManagingSession(w, w->session.connection);
***************
*** 1682,1687 ****
--- 1690,1696 ----
      FreeStringArray(w->session.environment);
      XtFree(w->session.current_dir);
      XtFree(w->session.program_path);
+ #endif /* !XT_NO_SM */
  }
  
  /*
***************
*** 2398,2403 ****
--- 2407,2413 ----
      ArgList args;
      Cardinal *num_args;
  {
+ #ifndef XT_NO_SM
      SessionShellWidget nw = (SessionShellWidget) new;
      SessionShellWidget cw = (SessionShellWidget) current;
      unsigned long set_mask = 0L;
***************
*** 2496,2501 ****
--- 2506,2512 ----
      if ((cw->session.join_session && !nw->session.join_session) ||
  	(cw->session.connection && !nw->session.connection))
  	StopManagingSession(nw, nw->session.connection);
+ #endif /* !XT_NO_SM */
  
      if (cw->wm.client_leader != nw->wm.client_leader ||
  	cw->session.session_id != nw->session.session_id) {
***************
*** 2612,2617 ****
--- 2623,2629 ----
  static void XtCallSaveCallbacks();
  static void XtCallSaveCompleteCallbacks();
  
+ #ifndef XT_NO_SM
  static void StopManagingSession(w, connection)
      SessionShellWidget w;
      SmcConn connection; /* connection to close, if any */
***************
*** 2696,2701 ****
--- 2708,2715 ----
  }
  #undef XT_MSG_LENGTH
  
+ #endif /* !XT_NO_SM */
+ 
  static String * NewStringArray(str)
      String *str;
  {
***************
*** 2734,2739 ****
--- 2748,2754 ----
  }
  
  
+ #ifndef XT_NO_SM
  static SmProp * CardPack(name, closure)
      char *name;
      XtPointer closure;
***************
*** 2900,2905 ****
--- 2915,2924 ----
      SessionShellWidget w = (SessionShellWidget) client_data;
      IceProcessMessagesStatus status;
  
+ #ifdef MINIX
+     if (!MNX_IceMessagesAvailable(SmcGetIceConnection(w->session.connection)))
+     	return;
+ #endif
      status = IceProcessMessages(SmcGetIceConnection(w->session.connection),
  				NULL, NULL);
  
***************
*** 3275,3277 ****
--- 3294,3297 ----
      return new;
  }
  
+ #endif /* !XT_NO_SM */
diff -c /dev/null xc/lib/Xt/Xtos2.def:3.0
*** /dev/null	Mon Jan 30 17:48:05 1995
--- xc/lib/Xt/Xtos2.def	Mon Jan 30 17:48:05 1995
***************
*** 0 ****
--- 1,471 ----
+ LIBRARY Xt
+ DESCRIPTION "X11R6 XFree86 libXt.dll for OS/2 EMX08H VERSION=6.0"
+ CODE
+ 	PRELOAD
+ DATA
+ 	SINGLE NONSHARED
+ STACKSIZE 32768
+ EXPORTS
+ 	XtAppAddActionHook  @ 1
+ 	XtRemoveActionHook  @ 2
+ 	XtMalloc  @ 3
+ 	XtRealloc  @ 4
+ 	XtCalloc  @ 5
+ 	XtFree  @ 6
+ 	XtMergeArgLists  @ 7
+ 	XtAddCallback  @ 8
+ 	XtAddCallbacks  @ 9
+ 	XtRemoveCallback  @ 10
+ 	XtRemoveCallbacks  @ 11
+ 	XtRemoveAllCallbacks  @ 12
+ 	XtCallCallbacks  @ 13
+ 	XtHasCallbacks  @ 14
+ 	XtCallCallbackList  @ 15
+ 	XtSetMultiClickTime  @ 16
+ 	XtGetMultiClickTime  @ 17
+ 	XtSetTypeConverter  @ 18
+ 	XtAppSetTypeConverter  @ 19
+ 	XtAddConverter  @ 20
+ 	XtAppAddConverter  @ 21
+ 	XtCallConverter  @ 22
+ 	XtConvert  @ 23
+ 	XtConvertAndStore  @ 24
+ 	XtAppReleaseCacheRefs  @ 25
+ 	XtCallbackReleaseCacheRefList  @ 26
+ 	XtCallbackReleaseCacheRef  @ 27
+ 	XtDisplayStringConversionWarning  @ 28
+ 	XtStringConversionWarning  @ 29
+ 	XtCvtIntToBoolean  @ 30
+ 	XtCvtIntToShort  @ 31
+ 	XtCvtStringToBoolean  @ 32 
+ 	XtCvtIntToBool  @ 33
+ 	XtCvtStringToBool  @ 34 
+ 	XtCvtIntToColor  @ 35
+ 	XtCvtStringToPixel  @ 36
+ 	XtCvtStringToCursor  @ 37
+ 	XtCvtStringToDisplay  @ 38
+ 	XtCvtStringToFile  @ 39
+ 	XtCvtIntToFloat  @ 40
+ 	XtCvtStringToFloat  @ 41
+ 	XtCvtStringToFont  @ 42
+ 	XtCvtIntToFont  @ 43
+ 	XtCvtStringToFontSet  @ 44
+ 	XtCvtStringToFontStruct  @ 45
+ 	XtCvtStringToInt  @ 46
+ 	XtCvtStringToShort  @ 47
+ 	XtCvtStringToDimension  @ 48
+ 	XtCvtIntToUnsignedChar  @ 49
+ 	XtCvtStringToUnsignedChar  @ 50
+ 	XtCvtColorToPixel  @ 51
+ 	XtCvtIntToPixel  @ 52
+ 	XtCvtIntToPixmap  @ 53
+ 	XtCvtStringToInitialState  @ 54
+ 	XtCvtStringToVisual  @ 55
+ 	XtCvtStringToAtom  @ 56
+ 	XtCvtStringToDirectoryString  @ 57
+ 	XtCvtStringToCommandArgArray  @ 58
+ 	XtInitializeWidgetClass  @ 59
+ 	XtCreateWidget  @ 60
+ 	XtCreateManagedWidget  @ 61
+ 	XtCreatePopupShell  @ 62
+ 	XtAppCreateShell  @ 63
+ 	XtCreateApplicationShell  @ 64
+ 	XtDestroyWidget  @ 65
+ 	XtOpenDisplay  @ 66
+ 	XtDisplayInitialize  @ 67
+ 	XtCreateApplicationContext  @ 68
+ 	XtDestroyApplicationContext  @ 69
+ 	XtDatabase  @ 70
+ 	XtDisplayToApplicationContext  @ 71
+ 	XtCloseDisplay  @ 72
+ 	XtWidgetToApplicationContext  @ 73
+ 	XtGetApplicationNameAndClass  @ 74
+ 	XtGetErrorDatabase  @ 75
+ 	XtAppGetErrorDatabase  @ 76
+ 	XtGetErrorDatabaseText  @ 77
+ 	XtAppGetErrorDatabaseText  @ 78
+ 	XtErrorMsg  @ 79
+ 	XtAppErrorMsg  @ 80
+ 	XtWarningMsg  @ 81
+ 	XtAppWarningMsg  @ 82
+ 	XtSetErrorMsgHandler  @ 83
+ 	XtAppSetErrorMsgHandler  @ 84
+ 	XtSetWarningMsgHandler  @ 85
+ 	XtAppSetWarningMsgHandler  @ 86
+ 	XtError  @ 87
+ 	XtAppError  @ 88
+ 	XtWarning  @ 89
+ 	XtAppWarning  @ 90
+ 	XtSetErrorHandler  @ 91
+ 	XtAppSetErrorHandler  @ 92
+ 	XtSetWarningHandler  @ 93
+ 	XtAppSetWarningHandler  @ 94
+ 	XtBuildEventMask  @ 95
+ 	XtRemoveEventHandler  @ 96
+ 	XtAddEventHandler  @ 97
+ 	XtInsertEventHandler  @ 98
+ 	XtRemoveRawEventHandler  @ 99
+ 	XtInsertRawEventHandler  @ 100
+ 	XtAddRawEventHandler  @ 101
+ 	XtWindowToWidget  @ 102
+ 	XtDispatchEvent  @ 103
+ 	XtAddGrab  @ 104
+ 	XtRemoveGrab  @ 105
+ 	XtMainLoop  @ 106
+ 	XtAppMainLoop  @ 107
+ 	XtAddExposureToRegion  @ 108
+ 	XtLastTimestampProcessed  @ 109
+ 	XtIsRectObj  @ 110
+ 	XtIsWidget  @ 111
+ 	XtIsComposite  @ 112
+ 	XtIsConstraint  @ 113
+ 	XtIsShell  @ 114
+ 	XtIsOverrideShell  @ 115
+ 	XtIsWMShell  @ 116
+ 	XtIsVendorShell  @ 117
+ 	XtIsTransientShell  @ 118
+ 	XtIsTopLevelShell  @ 119
+ 	XtIsApplicationShell  @ 120
+ 	XtMapWidget  @ 121
+ 	XtUnmapWidget  @ 122
+ 	XtNewString  @ 123
+ 	XtIsSessionShell  @ 124
+ 	XtAllocateGC  @ 125
+ 	XtGetGC  @ 126
+ 	XtReleaseGC  @ 127
+ 	XtDestroyGC  @ 128
+ 	XtMakeGeometryRequest  @ 129
+ 	XtMakeResizeRequest  @ 130
+ 	XtResizeWindow  @ 131
+ 	XtResizeWidget  @ 132
+ 	XtConfigureWidget  @ 133
+ 	XtMoveWidget  @ 134
+ 	XtTranslateCoords  @ 135
+ 	XtQueryGeometry  @ 136
+ 	XtGetActionKeysym  @ 137
+ 	XtGetResourceList  @ 138
+ 	XtGetConstraintResourceList  @ 139
+ 	XtGetValues  @ 140
+ 	XtGetSubvalues  @ 141
+ 	XtToolkitInitialize  @ 142
+ 	XtSetLanguageProc  @ 143
+ 	XtScreenDatabase  @ 144
+ 	XtAppSetFallbackResources  @ 145
+ 	XtAppInitialize  @ 146
+ 	XtInitialize  @ 147
+ 	XtOpenApplication  @ 148
+ 	XtIsSubclass  @ 149
+ 	XtRealizeWidget  @ 150
+ 	XtUnrealizeWidget  @ 151
+ 	XtCreateWindow  @ 152
+ 	XtNameToWidget  @ 153
+ 	XtDisplayOfObject  @ 154
+ 	XtDisplay  @ 155
+ 	XtScreenOfObject  @ 156
+ 	XtScreen  @ 157
+ 	XtWindowOfObject  @ 158
+ 	XtWindow  @ 159
+ 	XtSuperclass  @ 160
+ 	XtClass  @ 161
+ 	XtIsManaged  @ 162
+ 	XtIsRealized  @ 163
+ 	XtIsSensitive  @ 164
+ 	XtParent  @ 165
+ 	XtName  @ 166
+ 	XtIsObject  @ 167
+ 	XtFindFile  @ 168
+ 	XtResolvePathname  @ 169
+ 	XtCallAcceptFocus  @ 170
+ 	XtSetKeyboardFocus  @ 171
+ 	XtUnmanageChildren  @ 172
+ 	XtUnmanageChild  @ 173
+ 	XtManageChildren  @ 174
+ 	XtManageChild  @ 175
+ 	XtSetMappedWhenManaged  @ 176
+ 	XtAddTimeOut  @ 177
+ 	XtAppAddTimeOut  @ 178
+ 	XtRemoveTimeOut  @ 179
+ 	XtAddWorkProc  @ 180
+ 	XtAppAddWorkProc  @ 181
+ 	XtRemoveWorkProc  @ 182
+ 	XtAddInput  @ 183
+ 	XtAppAddInput  @ 184
+ 	XtRemoveInput  @ 185
+ 	XtNextEvent  @ 186
+ 	XtAppNextEvent  @ 187
+ 	XtProcessEvent  @ 188
+ 	XtAppProcessEvent  @ 189
+ 	XtPending  @ 190
+ 	XtAppPending  @ 191
+ 	XtPeekEvent  @ 192
+ 	XtAppPeekEvent  @ 193
+ 	XtGrabKey  @ 194
+ 	XtGrabButton  @ 195
+ 	XtUngrabKey  @ 196
+ 	XtUngrabButton  @ 197
+ 	XtGrabKeyboard  @ 198
+ 	XtUngrabKeyboard  @ 199
+ 	XtGrabPointer  @ 200
+ 	XtUngrabPointer  @ 201
+ 	XtPopup  @ 202
+ 	XtPopupSpringLoaded  @ 203
+ 	XtPopdown  @ 204
+ 	XtCallbackPopdown  @ 205
+ 	XtCallbackNone  @ 206
+ 	XtCallbackNonexclusive  @ 207
+ 	XtCallbackExclusive  @ 208
+ 	XtGetSubresources  @ 209
+ 	XtGetApplicationResources  @ 210
+ 	XtSetSelectionTimeout  @ 211
+ 	XtAppSetSelectionTimeout  @ 212
+ 	XtGetSelectionTimeout  @ 213
+ 	XtAppGetSelectionTimeout  @ 214
+ 	XtOwnSelection  @ 215
+ 	XtOwnSelectionIncremental  @ 216
+ 	XtDisownSelection  @ 217
+ 	XtGetSelectionValue  @ 218
+ 	XtGetSelectionValueIncremental  @ 219
+ 	XtGetSelectionValues  @ 220
+ 	XtGetSelectionValuesIncremental  @ 221
+ 	XtGetSelectionRequest  @ 222
+ 	XtSetSensitive  @ 223
+ 	XtSetSubvalues  @ 224
+ 	XtSetValues  @ 225
+ 	XtSetWMColormapWindows  @ 226
+ 	XtAddActions  @ 227
+ 	XtAppAddActions  @ 228
+ 	XtGetActionList  @ 229
+ 	XtMenuPopupAction  @ 230
+ 	XtCallActionProc  @ 231
+ 	XtRegisterGrabAction  @ 232
+ 	XtConvertCase  @ 233
+ 	XtTranslateKeycode  @ 234
+ 	XtTranslateKey  @ 235
+ 	XtSetKeyTranslator  @ 236
+ 	XtRegisterCaseConverter  @ 237
+ 	XtGetKeysymTable  @ 238
+ 	XtKeysymToKeycodeList  @ 239
+ 	XtCvtStringToAcceleratorTable  @ 240
+ 	XtCvtStringToTranslationTable  @ 241
+ 	XtParseAcceleratorTable  @ 242
+ 	XtParseTranslationTable  @ 243
+ 	XtUninstallTranslations  @ 244
+ 	XtInstallAccelerators  @ 245
+ 	XtInstallAllAccelerators  @ 246
+ 	XtAugmentTranslations  @ 247
+ 	XtOverrideTranslations  @ 248
+ 	XtVaCreateWidget  @ 249
+ 	XtVaCreateManagedWidget  @ 250
+ 	XtVaAppCreateShell  @ 251
+ 	XtVaCreatePopupShell  @ 252
+ 	XtVaSetValues  @ 253
+ 	XtVaSetSubvalues  @ 254
+ 	XtVaAppInitialize  @ 255
+ 	XtVaOpenApplication  @ 256
+ 	XtVaGetSubresources  @ 257
+ 	XtVaGetApplicationResources  @ 258
+ 	XtVaGetValues  @ 259
+ 	XtVaGetSubvalues  @ 260
+ 	XtVaCreateArgsList  @ 261
+ 	XtCvtStringToRestartStyle  @ 262
+ 	XtCvtStringToGravity  @ 263
+ 	XtAppSetExitFlag  @ 264
+ 	XtAppGetExitFlag  @ 265
+ 	XtGetDisplays  @ 266
+ 	XtRemoveEventTypeHandler  @ 267
+ 	XtInsertEventTypeHandler  @ 268
+ 	XtRegisterDrawable  @ 269
+ 	XtUnregisterDrawable  @ 270
+ 	XtDispatchEventToWidget  @ 271
+ 	XtLastEventProcessed  @ 272
+ 	XtSetEventDispatcher  @ 273
+ 	XtRegisterExtensionSelector  @ 274
+ 	XtAppAddBlockHook  @ 275
+ 	XtRemoveBlockHook  @ 276
+ 	XtHooksOfDisplay  @ 277
+ 	XtGetClassExtension  @ 278
+ 	XtGetKeyboardFocusWidget  @ 279
+ 	XtChangeManagedSet  @ 280
+ 	XtAddSignal  @ 281
+ 	XtAppAddSignal  @ 282
+ 	XtRemoveSignal  @ 283
+ 	XtNoticeSignal  @ 284
+ 	XtReservePropertyAtom  @ 285
+ 	XtReleasePropertyAtom  @ 286
+ 	XtCreateSelectionRequest  @ 287
+ 	XtSendSelectionRequest  @ 288
+ 	XtCancelSelectionRequest  @ 289
+ 	XtSetSelectionParameters  @ 290
+ 	XtGetSelectionParameters  @ 291
+ 	XtSessionGetToken  @ 292
+ 	XtSessionReturnToken  @ 293
+ 	XtAppLock  @ 294
+ 	XtAppUnlock  @ 295
+ 	XtProcessLock  @ 296
+ 	XtProcessUnlock  @ 297
+ 	XtToolkitThreadInitialize  @ 298
+ 	_XtDoFreeBindings  @ 299
+ 	_XtAllocError  @ 300
+ 	_XtHeapInit  @ 301
+ 	_XtHeapAlloc  @ 302
+ 	_XtHeapFree  @ 303
+ 	_XtAddCallback  @ 304
+ 	_XtAddCallbackOnce  @ 305
+ 	_XtRemoveCallback  @ 306
+ 	_XtRemoveAllCallbacks  @ 307
+ 	_XtCompileCallbackList  @ 308
+ 	_XtGetCallbackList  @ 309
+ 	_XtCallConditionalCallbackList  @ 310
+ 	_XtSetDefaultConverterTable  @ 311
+ 	_XtFreeConverterTable  @ 312
+ 	_XtTableAddConverter  @ 313
+ 	_XtCacheFlushTag  @ 314
+ 	_XtConvert  @ 315
+ 	_XtConvertInitialize  @ 316
+  	_XtAddDefaultConverters  @ 317
+ 	_XtCreateWidget  @ 318
+ 	_XtCreatePopupShell  @ 319
+ 	_XtAppCreateShell  @ 320
+ 	_XtDoPhase2Destroy  @ 321
+ 	_XtGetProcessContext  @ 322
+ 	_XtDefaultAppContext  @ 323
+ 	_XtAppInit  @ 324
+ 	_XtDestroyAppContexts  @ 325
+ 	_XtSortPerDisplayList  @ 326
+ 	_XtCloseDisplays  @ 327
+ 	_XtDefaultErrorMsg  @ 328
+ 	_XtDefaultWarningMsg  @ 329
+ 	_XtDefaultError  @ 330
+ 	_XtDefaultWarning  @ 331
+ 	_XtSetDefaultErrorHandlers  @ 332
+ 	_XtAllocWWTable  @ 333
+ 	_XtFreeWWTable  @ 334
+ 	_XtConvertTypeToMask  @ 335
+ 	_XtOnGrabList  @ 336
+ 	_XtEventInitialize  @ 337
+ 	_XtFreeEventTable  @ 338
+ 	_XtSendFocusEvent  @ 339
+ 	_XtFreePerWidgetInput  @ 340
+ 	_XtGetPerWidgetInput  @ 341
+ 	_XtFillAncestorList  @ 342
+ 	_XtFindRemapWidget  @ 343
+ 	_XtUngrabBadGrabs  @ 344
+ 	_XtGClistFree  @ 345
+ 	_XtMakeGeometryRequest  @ 346
+ 	_XtInherit  @ 347
+ 	_XtPreparseCommandLine  @ 348
+ 	_XtDisplayInitialize  @ 349
+ 	_XtCheckSubclassFlag  @ 350
+ 	_XtIsSubclassOf  @ 351
+ 	_XtWindowedAncestor  @ 352
+ 	_XtProcessKeyboardEvent  @ 353
+ 	_XtHandleFocus  @ 354
+ 	_XtRemoveAllInputs  @ 355
+ 	_XtRefreshMapping  @ 356
+ 	_XtDestroyServerGrabs  @ 357
+ 	_XtCheckServerGrabsOnWidget  @ 358
+ 	_XtProcessPointerEvent  @ 359
+ 	_XtPopup  @ 360
+ 	_XtCopyFromParent  @ 361
+ 	_XtCopyFromArg  @ 362
+ 	_XtCopyToArg  @ 363
+ 	_XtCompileResourceList  @ 364
+ 	_XtDependencies  @ 365
+ 	_XtResourceDependencies  @ 366
+ 	_XtConstraintResDependencies  @ 367
+ 	_XtCreateIndirectionTable  @ 368
+ 	_XtGetResources  @ 369
+ 	_XtResourceListInitialize  @ 370
+ 	_XtSetDefaultSelectionTimeout  @ 371
+ 	_XtShellGetCoordinates  @ 372
+ 	_XtInitializeActionData  @ 373
+ 	_XtBindActions  @ 374
+ 	_XtUnbindActions  @ 375
+ 	_XtFreeActions  @ 376
+ 	_XtRegisterGrabs  @ 377
+ 	_XtGrabInitialize  @ 378
+ 	_XtComputeLateBindings  @ 379
+ 	_XtAllocTMContext  @ 380
+ 	_XtMatchUsingDontCareMods  @ 381
+ 	_XtMatchUsingStandardMods  @ 382
+ 	_XtBuildKeysymTables  @ 383
+ 	_XtTranslateInitialize  @ 384
+ 	_XtAddTMConverters  @ 385
+ 	_XtPrintXlations  @ 386
+ 	_XtDisplayTranslations  @ 387
+ 	_XtDisplayAccelerators  @ 388
+ 	_XtDisplayInstalledAccelerators  @ 389
+ 	_XtPrintActions  @ 390
+ 	_XtPrintState  @ 391
+ 	_XtPrintEventSeq  @ 392
+ 	_XtGetQuarkIndex  @ 393
+ 	_XtGetTypeIndex  @ 394
+ 	_XtGetModifierIndex  @ 395
+ 	_XtRegularMatch  @ 396
+ 	_XtMatchAtom  @ 397
+ 	_XtTranslateEvent  @ 398
+ 	_XtTraverseStateTree  @ 399
+ 	_XtInstallTranslations  @ 400
+ 	_XtRemoveTranslations  @ 401
+ 	_XtDestroyTMData  @ 402
+ 	_XtCreateXlations  @ 403
+ 	_XtParseTreeToStateTree  @ 404
+ 	_XtAddEventSeqToStateTree  @ 405
+ 	_XtCvtMergeTranslations  @ 406
+ 	_XtGetTranslationValue  @ 407
+ 	_XtRemoveStateTreeByIndex  @ 408
+ 	_XtFreeTranslations  @ 409
+ 	_XtMergeTranslations  @ 410
+ 	_XtUnmergeTranslations  @ 411
+ 	_XtPopupInitialize  @ 412
+ 	_XtVaAppInitialize  @ 413
+ 	_XtVaOpenApplication  @ 414
+ 	_XtCountVaList  @ 415
+ 	_XtVaCreateTypedArgList  @ 416
+ 	_XtVaToArgList  @ 417
+ 	_XtVaToTypedArgList  @ 418
+ 	_XtPeekCallback  @ 419
+ 	_XtCreateHookObj  @ 420
+ 	_XtGetPerDisplay  @ 421
+ 	_XtGetPerDisplayInput  @ 422
+ 	_XtExtensionSelect  @ 423
+ 	_XtAddShellToHookObj  @ 424
+ 	_XtIsHookObject  @ 425
+ 	_XtGetUserName  @ 426
+ 	_XtWaitForSomething  @ 427
+ 	XtDirectConvert @ 433
+ 	colorConvertArgs @ 435
+ 	screenConvertArg @ 436
+ 	XtCXtToolkitError @ 437
+ 	_XtQString @ 438
+ 	_XtAppDestroyCount @ 439
+ 	_XtPerDisplayList @ 440
+ 	_XtGlobalTM @ 444
+ 	XtStrings @ 445
+ 	overrideShellClassRec @ 446
+ 	overrideShellWidgetClass @ 447
+ 	constraintClassRec @ 448
+ 	constraintWidgetClass @ 449
+ 	objectClassRec @ 450
+ 	objectClass @ 451
+ 	widgetClassRec @ 452
+ 	widgetClass @ 453
+ 	rectObjClassRec @ 454
+ 	rectObjClass @ 455
+ 	coreWidgetClass @ 457
+ 	wmShellClassRec @ 458
+ 	wmShellWidgetClass @ 459
+ 	XtShellStrings @ 460
+ 	topLevelShellClassRec @ 461
+ 	topLevelShellWidgetClass @ 462
+ 	transientShellClassRec @ 463
+ 	transientShellWidgetClass @ 464
+ 	shellClassRec @ 465
+ 	shellWidgetClass @ 466
+ 	compositeClassRec @ 467
+ 	compositeWidgetClass @ 468
+ 	applicationShellClassRec @ 469
+ 	applicationShellWidgetClass @ 470
+ 	_XtInheritTranslations @ 471
+ 	sessionShellClassRec @ 472
+ 	sessionShellWidgetClass @ 473
